diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc ns-3.44/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc
--- ns-3.43/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2025-03-09 16:55:49.795372700 -0700
@@ -1240,11 +1200,11 @@
 MinstrelHtWifiManager::GetNextSample(MinstrelHtWifiRemoteStation* station)
 {
     NS_LOG_FUNCTION(this << station);
-    uint8_t sampleGroup = station->m_sampleGroup;
-    uint8_t index = station->m_groupsTable[sampleGroup].m_index;
-    uint8_t col = station->m_groupsTable[sampleGroup].m_col;
-    uint8_t sampleIndex = station->m_sampleTable[index][col];
-    uint16_t rateIndex = GetIndex(sampleGroup, sampleIndex);
+    const auto sampleGroup = station->m_sampleGroup;
+    const auto index = station->m_groupsTable[sampleGroup].m_index;
+    const auto col = station->m_groupsTable[sampleGroup].m_col;
+    const auto sampleIndex = station->m_sampleTable[index][col];
+    const auto rateIndex = GetIndex(sampleGroup, sampleIndex);
     NS_LOG_DEBUG("Next Sample is " << rateIndex);
     SetNextSample(station); // Calculate the next sample rate.
     return rateIndex;
@@ -1262,9 +1222,9 @@
 
     station->m_groupsTable[station->m_sampleGroup].m_index++;
 
-    uint8_t sampleGroup = station->m_sampleGroup;
-    uint8_t index = station->m_groupsTable[station->m_sampleGroup].m_index;
-    uint8_t col = station->m_groupsTable[sampleGroup].m_col;
+    const auto sampleGroup = station->m_sampleGroup;
+    auto index = station->m_groupsTable[station->m_sampleGroup].m_index;
+    auto col = station->m_groupsTable[sampleGroup].m_col;
 
     if (index >= m_numRates)
     {
@@ -1298,12 +1258,12 @@
         // SAMPLING
         NS_LOG_DEBUG("Obtaining a sampling rate");
         /// Now go through the table and find an index rate.
-        uint16_t sampleIdx = GetNextSample(station);
+        const auto sampleIdx = GetNextSample(station);
         NS_LOG_DEBUG("Sampling rate = " << sampleIdx);
 
         // Evaluate if the sampling rate selected should be used.
-        uint8_t sampleGroupId = GetGroupId(sampleIdx);
-        uint8_t sampleRateId = GetRateId(sampleIdx);
+        const auto sampleGroupId = GetGroupId(sampleIdx);
+        const auto sampleRateId = GetRateId(sampleIdx);
 
         // If the rate selected is not supported, then don't sample.
         if (station->m_groupsTable[sampleGroupId].m_supported &&
@@ -1316,7 +1276,7 @@
              * Also do not sample if the probability is already higher than 95%
              * to avoid wasting airtime.
              */
-            MinstrelHtRateInfo sampleRateInfo =
+            const auto sampleRateInfo =
                 station->m_groupsTable[sampleGroupId].m_ratesTable[sampleRateId];
 
             NS_LOG_DEBUG("Use sample rate? MaxTpRate= "
@@ -1332,21 +1292,21 @@
                  * if the link is working perfectly.
                  */
 
-                uint8_t maxTpGroupId = GetGroupId(station->m_maxTpRate);
-                uint8_t maxTp2GroupId = GetGroupId(station->m_maxTpRate2);
-                uint8_t maxTp2RateId = GetRateId(station->m_maxTpRate2);
-                uint8_t maxProbGroupId = GetGroupId(station->m_maxProbRate);
-                uint8_t maxProbRateId = GetRateId(station->m_maxProbRate);
+                const auto maxTpGroupId = GetGroupId(station->m_maxTpRate);
+                const auto maxTp2GroupId = GetGroupId(station->m_maxTpRate2);
+                const auto maxTp2RateId = GetRateId(station->m_maxTpRate2);
+                const auto maxProbGroupId = GetGroupId(station->m_maxProbRate);
+                const auto maxProbRateId = GetRateId(station->m_maxProbRate);
 
-                uint8_t maxTpStreams = m_minstrelGroups[maxTpGroupId].streams;
-                uint8_t sampleStreams = m_minstrelGroups[sampleGroupId].streams;
+                const auto maxTpStreams = m_minstrelGroups[maxTpGroupId].streams;
+                const auto sampleStreams = m_minstrelGroups[sampleGroupId].streams;
 
-                Time sampleDuration = sampleRateInfo.perfectTxTime;
-                Time maxTp2Duration =
+                const auto sampleDuration = sampleRateInfo.perfectTxTime;
+                const auto maxTp2Duration =
                     station->m_groupsTable[maxTp2GroupId].m_ratesTable[maxTp2RateId].perfectTxTime;
-                Time maxProbDuration = station->m_groupsTable[maxProbGroupId]
-                                           .m_ratesTable[maxProbRateId]
-                                           .perfectTxTime;
+                const auto maxProbDuration = station->m_groupsTable[maxProbGroupId]
+                                                 .m_ratesTable[maxProbRateId]
+                                                 .perfectTxTime;
 
                 NS_LOG_DEBUG("Use sample rate? SampleDuration= "
                              << sampleDuration << " maxTp2Duration= " << maxTp2Duration
@@ -1425,7 +1385,7 @@
     station->m_maxProbRate = GetLowestIndex(station);
 
     /// Update throughput and EWMA for each rate inside each group.
-    for (uint8_t j = 0; j < m_numGroups; j++)
+    for (std::size_t j = 0; j < m_numGroups; j++)
     {
         if (station->m_groupsTable[j].m_supported)
         {
@@ -1534,7 +1494,7 @@
 
 double
 MinstrelHtWifiManager::CalculateThroughput(MinstrelHtWifiRemoteStation* station,
-                                           uint8_t groupId,
+                                           std::size_t groupId,
                                            uint8_t rateId,
                                            double ewmaProb)
 {
@@ -1553,7 +1513,7 @@
          * For the throughput calculation, limit the probability value to 90% to
          * account for collision related packet error rate fluctuation.
          */
-        Time txTime = station->m_groupsTable[groupId].m_ratesTable[rateId].perfectTxTime;
+        const auto txTime = station->m_groupsTable[groupId].m_ratesTable[rateId].perfectTxTime;
         if (ewmaProb > 90)
         {
             return 90 / txTime.GetSeconds();
@@ -1570,15 +1530,15 @@
 {
     GroupInfo* group;
     MinstrelHtRateInfo rate;
-    uint8_t tmpGroupId;
+    std::size_t tmpGroupId;
     uint8_t tmpRateId;
     double tmpTh;
     double tmpProb;
-    uint8_t groupId;
+    std::size_t groupId;
     uint8_t rateId;
     double currentTh;
     // maximum group probability (GP) variables
-    uint8_t maxGPGroupId;
+    std::size_t maxGPGroupId;
     uint8_t maxGPRateId;
     double maxGPTh;
 
@@ -1633,13 +1593,13 @@
 void
 MinstrelHtWifiManager::SetBestStationThRates(MinstrelHtWifiRemoteStation* station, uint16_t index)
 {
-    uint8_t groupId;
+    std::size_t groupId;
     uint8_t rateId;
     double th;
     double prob;
-    uint8_t maxTpGroupId;
+    std::size_t maxTpGroupId;
     uint8_t maxTpRateId;
-    uint8_t maxTp2GroupId;
+    std::size_t maxTp2GroupId;
     uint8_t maxTp2RateId;
     double maxTpTh;
     double maxTpProb;
@@ -1707,7 +1667,7 @@
      */
     NS_LOG_DEBUG("Supported groups by station:");
     bool noSupportedGroupFound = true;
-    for (uint8_t groupId = 0; groupId < m_numGroups; groupId++)
+    for (std::size_t groupId = 0; groupId < m_numGroups; groupId++)
     {
         if (m_minstrelGroups[groupId].isSupported)
         {
@@ -1740,15 +1700,14 @@
                 // UseLatestAmendmentOnly attribute is enabled
                 continue;
             }
-            if (((m_minstrelGroups[groupId].type == WIFI_MINSTREL_GROUP_HT) ||
-                 (m_minstrelGroups[groupId].type == WIFI_MINSTREL_GROUP_VHT)) &&
+            if ((m_minstrelGroups[groupId].type < WIFI_MINSTREL_GROUP_HE) &&
                 (m_minstrelGroups[groupId].gi.GetNanoSeconds() == 400) &&
                 !GetShortGuardIntervalSupported(station))
             {
                 // It is a SGI group but the receiver does not support SGI: skip
                 continue;
             }
-            if ((m_minstrelGroups[groupId].type == WIFI_MINSTREL_GROUP_HE) &&
+            if ((m_minstrelGroups[groupId].type >= WIFI_MINSTREL_GROUP_HE) &&
                 (m_minstrelGroups[groupId].gi < GetGuardInterval(station)))
             {
                 // The receiver does not support the GI: skip
@@ -1765,7 +1724,7 @@
                 continue;
             }
 
-            NS_LOG_DEBUG("Group: " << +groupId << " type: " << m_minstrelGroups[groupId].type
+            NS_LOG_DEBUG("Group: " << groupId << " type: " << m_minstrelGroups[groupId].type
                                    << " streams: " << +m_minstrelGroups[groupId].streams
                                    << " GI: " << m_minstrelGroups[groupId].gi
                                    << " width: " << m_minstrelGroups[groupId].chWidth);
@@ -1786,40 +1745,19 @@
             // group.
             for (uint8_t i = 0; i < station->m_nModes; i++)
             {
-                WifiMode mode = GetMcsSupported(station, i);
-
-                /// Use the McsValue as the index in the rate table.
-                /// This way, MCSs not supported are not initialized.
-                uint8_t rateId = mode.GetMcsValue();
-                if (mode.GetModulationClass() == WIFI_MOD_CLASS_HT)
-                {
-                    rateId %= MAX_HT_GROUP_RATES;
-                }
-
-                if (((m_minstrelGroups[groupId].type == WIFI_MINSTREL_GROUP_HE) &&
-                     (mode.GetModulationClass() ==
-                      WIFI_MOD_CLASS_HE) /// If it is a HE MCS only add to a HE group.
-                     && IsValidMcs(GetPhy(),
-                                   m_minstrelGroups[groupId].streams,
-                                   m_minstrelGroups[groupId].chWidth,
-                                   mode)) /// Check validity of the HE MCS
-                    || ((m_minstrelGroups[groupId].type == WIFI_MINSTREL_GROUP_VHT) &&
-                        (mode.GetModulationClass() ==
-                         WIFI_MOD_CLASS_VHT) /// If it is a VHT MCS only add to a VHT group.
-                        && IsValidMcs(GetPhy(),
-                                      m_minstrelGroups[groupId].streams,
-                                      m_minstrelGroups[groupId].chWidth,
-                                      mode)) /// Check validity of the VHT MCS
-                    || ((m_minstrelGroups[groupId].type == WIFI_MINSTREL_GROUP_HT) &&
-                        (mode.GetModulationClass() ==
-                         WIFI_MOD_CLASS_HT) /// If it is a HT MCS only add to a HT group.
-                        && (mode.GetMcsValue() <
-                            (m_minstrelGroups[groupId].streams *
-                             8)) /// Check if the HT MCS corresponds to groups number of streams.
-                        && (mode.GetMcsValue() >= ((m_minstrelGroups[groupId].streams - 1) * 8))))
+                if (const auto mode = GetMcsSupported(station, i);
+                    ShouldAddMcsToGroup(mode, groupId))
                 {
                     NS_LOG_DEBUG("Mode " << +i << ": " << mode);
 
+                    /// Use the McsValue as the index in the rate table.
+                    /// This way, MCSs not supported are not initialized.
+                    auto rateId = mode.GetMcsValue();
+                    if (mode.GetModulationClass() == WIFI_MOD_CLASS_HT)
+                    {
+                        rateId %= (minstrelHtStandardInfos.at(WIFI_MOD_CLASS_HT).maxMcs + 1);
+                    }
+
                     station->m_groupsTable[groupId].m_ratesTable[rateId].supported = true;
                     station->m_groupsTable[groupId].m_ratesTable[rateId].mcsIndex =
                         i; /// Mapping between rateId and operationalMcsSet
@@ -1857,8 +1795,8 @@
 MinstrelHtWifiManager::CalculateRetransmits(MinstrelHtWifiRemoteStation* station, uint16_t index)
 {
     NS_LOG_FUNCTION(this << station << index);
-    uint8_t groupId = GetGroupId(index);
-    uint8_t rateId = GetRateId(index);
+    const auto groupId = GetGroupId(index);
+    const auto rateId = GetRateId(index);
     if (!station->m_groupsTable[groupId].m_ratesTable[rateId].retryUpdated)
     {
         CalculateRetransmits(station, groupId, rateId);
@@ -1867,18 +1805,18 @@
 
 void
 MinstrelHtWifiManager::CalculateRetransmits(MinstrelHtWifiRemoteStation* station,
-                                            uint8_t groupId,
+                                            std::size_t groupId,
                                             uint8_t rateId)
 {
-    NS_LOG_FUNCTION(this << station << +groupId << +rateId);
+    NS_LOG_FUNCTION(this << station << groupId << rateId);
 
     uint32_t cw = 15; // Is an approximation.
     uint32_t cwMax = 1023;
     Time cwTime;
     Time txTime;
     Time dataTxTime;
-    Time slotTime = GetPhy()->GetSlot();
-    Time ackTime = GetPhy()->GetSifs() + GetPhy()->GetBlockAckTxTime();
+    const auto slotTime = GetPhy()->GetSlot();
+    const auto ackTime = GetPhy()->GetSifs() + GetPhy()->GetBlockAckTxTime();
 
     if (station->m_groupsTable[groupId].m_ratesTable[rateId].ewmaProb < 1)
     {
@@ -1950,7 +1888,7 @@
     station->m_col = station->m_index = 0;
 
     // for off-setting to make rates fall between 0 and nModes
-    uint8_t numSampleRates = m_numRates;
+    auto numSampleRates = m_numRates;
 
     uint16_t newIndex;
     for (uint8_t col = 0; col < m_nSampleCol; col++)
@@ -1989,7 +1927,7 @@
            "________last_______    ______sum-of________\n"
         << " mode guard #  rate  [name   idx airtime  max_tp]  [avg(tp) avg(prob) sd(prob)]  "
            "[prob.|retry|suc|att]  [#success | #attempts]\n";
-    for (uint8_t i = 0; i < m_numGroups; i++)
+    for (std::size_t i = 0; i < m_numGroups; i++)
     {
         StatsDump(station, i, station->m_statsFile);
     }
@@ -2005,10 +1943,10 @@
 
 void
 MinstrelHtWifiManager::StatsDump(MinstrelHtWifiRemoteStation* station,
-                                 uint8_t groupId,
+                                 std::size_t groupId,
                                  std::ofstream& of)
 {
-    uint8_t numRates = m_numRates;
+    auto numRates = m_numRates;
     McsGroup group = m_minstrelGroups[groupId];
     Time txTime;
     for (uint8_t i = 0; i < numRates; i++)
@@ -2019,11 +1957,11 @@
             of << group.type << " " << group.chWidth << "   " << group.gi << "  " << +group.streams
                << "   ";
 
-            uint16_t maxTpRate = station->m_maxTpRate;
-            uint16_t maxTpRate2 = station->m_maxTpRate2;
-            uint16_t maxProbRate = station->m_maxProbRate;
+            const auto maxTpRate = station->m_maxTpRate;
+            const auto maxTpRate2 = station->m_maxTpRate2;
+            const auto maxProbRate = station->m_maxProbRate;
 
-            uint16_t idx = GetIndex(groupId, i);
+            const auto idx = GetIndex(groupId, i);
             if (idx == maxTpRate)
             {
                 of << 'A';
@@ -2051,14 +1989,17 @@
 
             if (group.type == WIFI_MINSTREL_GROUP_HT)
             {
-                of << std::setw(4) << "   MCS" << (group.streams - 1) * 8 + i;
+                of << std::setw(4) << "   MCS"
+                   << (group.streams - 1) *
+                              (minstrelHtStandardInfos.at(WIFI_MOD_CLASS_HT).maxMcs + 1) +
+                          i;
             }
             else
             {
                 of << std::setw(7) << "   MCS" << +i << "/" << static_cast<int>(group.streams);
             }
 
-            of << "  " << std::setw(3) << +idx << "  ";
+            of << "  " << std::setw(3) << idx << "  ";
 
             /* tx_time[rate(i)] in usec */
             txTime = GetFirstMpduTxTime(
@@ -2084,114 +2025,97 @@
 }
 
 uint16_t
-MinstrelHtWifiManager::GetIndex(uint8_t groupId, uint8_t rateId)
+MinstrelHtWifiManager::GetIndex(std::size_t groupId, uint8_t rateId)
 {
-    NS_LOG_FUNCTION(this << +groupId << +rateId);
-    uint16_t index;
-    index = groupId * m_numRates + rateId;
-    return index;
+    NS_LOG_FUNCTION(this << groupId << rateId);
+    return groupId * m_numRates + rateId;
 }
 
 uint8_t
 MinstrelHtWifiManager::GetRateId(uint16_t index)
 {
     NS_LOG_FUNCTION(this << index);
-    uint8_t id;
-    id = index % m_numRates;
-    return id;
+    return index % m_numRates;
 }
 
-uint8_t
+std::size_t
 MinstrelHtWifiManager::GetGroupId(uint16_t index)
 {
     NS_LOG_FUNCTION(this << index);
     return index / m_numRates;
 }
 
-uint8_t
-MinstrelHtWifiManager::GetHtGroupId(uint8_t txstreams, Time guardInterval, MHz_u chWidth)
+std::size_t
+MinstrelHtWifiManager::GetIdInGroup(WifiModulationClass mc,
+                                    uint8_t streams,
+                                    Time guardInterval,
+                                    MHz_u chWidth)
 {
-    NS_LOG_FUNCTION(this << +txstreams << guardInterval << chWidth);
-    uint8_t giIndex = (guardInterval.GetNanoSeconds() == 400) ? 1 : 0;
-    uint8_t widthIndex = (chWidth == 40) ? 1 : 0;
-    return (MAX_HT_SUPPORTED_STREAMS * 2 * widthIndex) + (MAX_HT_SUPPORTED_STREAMS * giIndex) +
-           txstreams - 1;
+    NS_LOG_FUNCTION(this << mc << streams << guardInterval << chWidth);
+    const auto& standardInfos = minstrelHtStandardInfos.at(mc);
+    const auto it = std::find(standardInfos.guardIntervals.cbegin(),
+                              standardInfos.guardIntervals.cend(),
+                              guardInterval);
+    const auto giIndex = std::distance(standardInfos.guardIntervals.cbegin(), it);
+    const auto widthIndex = std::log2(chWidth / MHz_u{20});
+    return (standardInfos.maxStreams * standardInfos.guardIntervals.size() * widthIndex) +
+           (standardInfos.maxStreams * giIndex) + streams - 1;
 }
 
-uint8_t
-MinstrelHtWifiManager::GetVhtGroupId(uint8_t txstreams, Time guardInterval, MHz_u chWidth)
+std::size_t
+MinstrelHtWifiManager::GetNumGroups(WifiModulationClass mc)
 {
-    NS_LOG_FUNCTION(this << +txstreams << guardInterval << chWidth);
-    uint8_t giIndex = (guardInterval.GetNanoSeconds() == 400) ? 1 : 0;
-    uint8_t widthIndex;
-    if (chWidth == 160)
-    {
-        widthIndex = 3;
-    }
-    else if (chWidth == 80)
-    {
-        widthIndex = 2;
-    }
-    else if (chWidth == 40)
-    {
-        widthIndex = 1;
-    }
-    else // 20 MHz
-    {
-        widthIndex = 0;
-    }
-    uint8_t groupId = (MAX_HT_STREAM_GROUPS * MAX_HT_SUPPORTED_STREAMS); /// add all HT groups
-    groupId += (MAX_VHT_SUPPORTED_STREAMS * 2 * widthIndex) +
-               (MAX_VHT_SUPPORTED_STREAMS * giIndex) + txstreams - 1;
-    return groupId;
+    const auto& standardInfos = minstrelHtStandardInfos.at(mc);
+    const auto numWidths = std::log2(standardInfos.maxWidth / MHz_u{20}) + 1;
+    return numWidths * standardInfos.guardIntervals.size() * standardInfos.maxStreams;
 }
 
-uint8_t
-MinstrelHtWifiManager::GetHeGroupId(uint8_t txstreams, Time guardInterval, MHz_u chWidth)
+std::size_t
+MinstrelHtWifiManager::GetHtGroupId(uint8_t streams, Time guardInterval, MHz_u chWidth)
 {
-    NS_LOG_FUNCTION(this << +txstreams << guardInterval << chWidth);
-    uint8_t giIndex;
-    if (const auto gi = guardInterval.GetNanoSeconds(); gi == 800)
-    {
-        giIndex = 2;
-    }
-    else if (gi == 1600)
-    {
-        giIndex = 1;
-    }
-    else // 3200 ns
-    {
-        giIndex = 0;
-    }
-    uint8_t widthIndex;
-    if (chWidth == 160)
-    {
-        widthIndex = 3;
-    }
-    else if (chWidth == 80)
-    {
-        widthIndex = 2;
-    }
-    else if (chWidth == 40)
-    {
-        widthIndex = 1;
-    }
-    else // 20 MHz
-    {
-        widthIndex = 0;
-    }
-    uint8_t groupId = 0;
-    if (GetHtSupported()) // This check is needed since HT is not supported in 6 GHz band
-    {
-        groupId = MAX_HT_STREAM_GROUPS * MAX_HT_SUPPORTED_STREAMS;
-    }
-    if (GetVhtSupported()) // This check is needed since VHT is not supported in 2.4 and 6 GHz bands
+    NS_LOG_FUNCTION(this << streams << guardInterval << chWidth);
+    return GetIdInGroup(WIFI_MOD_CLASS_HT, streams, guardInterval, chWidth);
+}
+
+std::size_t
+MinstrelHtWifiManager::GetVhtGroupId(uint8_t streams, Time guardInterval, MHz_u chWidth)
+{
+    NS_LOG_FUNCTION(this << streams << guardInterval << chWidth);
+    const auto allHtGroups = GetNumGroups(WIFI_MOD_CLASS_HT);
+    const auto vhtGroupId = GetIdInGroup(WIFI_MOD_CLASS_VHT, streams, guardInterval, chWidth);
+    return allHtGroups + vhtGroupId;
+}
+
+std::size_t
+MinstrelHtWifiManager::GetHeGroupId(uint8_t streams, Time guardInterval, MHz_u chWidth)
+{
+    NS_LOG_FUNCTION(this << streams << guardInterval << chWidth);
+    // This check is needed since HT is not supported in 6 GHz band
+    std::size_t allHtGroups = (GetHtSupported()) ? GetNumGroups(WIFI_MOD_CLASS_HT) : 0;
+    // This check is needed since VHT is not supported in 2.4 and 6 GHz bands
+    std::size_t allVhtGroups = (GetVhtSupported()) ? GetNumGroups(WIFI_MOD_CLASS_VHT) : 0;
+    const auto heGroupId = GetIdInGroup(WIFI_MOD_CLASS_HE, streams, guardInterval, chWidth);
+    return allHtGroups + allVhtGroups + heGroupId;
+}
+
+std::size_t
+MinstrelHtWifiManager::GetGroupIdForType(McsGroupType type,
+                                         uint8_t streams,
+                                         Time guardInterval,
+                                         MHz_u chWidth)
+{
+    switch (type)
     {
-        groupId += MAX_VHT_STREAM_GROUPS * MAX_VHT_SUPPORTED_STREAMS; /// add all VHT groups
+    case WIFI_MINSTREL_GROUP_HT:
+        return GetHtGroupId(streams, guardInterval, chWidth);
+    case WIFI_MINSTREL_GROUP_VHT:
+        return GetVhtGroupId(streams, guardInterval, chWidth);
+    case WIFI_MINSTREL_GROUP_HE:
+        return GetHeGroupId(streams, guardInterval, chWidth);
+    default:
+        NS_ABORT_MSG("Unknown group type: " << type);
     }
-    groupId += (MAX_HE_SUPPORTED_STREAMS * 3 * widthIndex) + (MAX_HE_SUPPORTED_STREAMS * giIndex) +
-               txstreams - 1;
-    return groupId;
+    return 0;
 }
 
 uint16_t
@@ -2199,7 +2123,7 @@
 {
     NS_LOG_FUNCTION(this << station);
 
-    uint8_t groupId = 0;
+    std::size_t groupId = 0;
     uint8_t rateId = 0;
     while (groupId < m_numGroups && !station->m_groupsTable[groupId].m_supported)
     {
@@ -2215,9 +2139,9 @@
 }
 
 uint16_t
-MinstrelHtWifiManager::GetLowestIndex(MinstrelHtWifiRemoteStation* station, uint8_t groupId)
+MinstrelHtWifiManager::GetLowestIndex(MinstrelHtWifiRemoteStation* station, std::size_t groupId)
 {
-    NS_LOG_FUNCTION(this << station << +groupId);
+    NS_LOG_FUNCTION(this << station << groupId);
 
     uint8_t rateId = 0;
     while (rateId < m_numRates && !station->m_groupsTable[groupId].m_ratesTable[rateId].supported)
@@ -2230,27 +2154,11 @@
 }
 
 WifiModeList
-MinstrelHtWifiManager::GetHeDeviceMcsList() const
-{
-    const auto& mcsList = GetPhy()->GetMcsList(WIFI_MOD_CLASS_HE);
-    WifiModeList heMcsList(mcsList.begin(), mcsList.end());
-    return heMcsList;
-}
-
-WifiModeList
-MinstrelHtWifiManager::GetVhtDeviceMcsList() const
-{
-    const auto& mcsList = GetPhy()->GetMcsList(WIFI_MOD_CLASS_VHT);
-    WifiModeList vhtMcsList(mcsList.begin(), mcsList.end());
-    return vhtMcsList;
-}
-
-WifiModeList
-MinstrelHtWifiManager::GetHtDeviceMcsList() const
+MinstrelHtWifiManager::GetDeviceMcsList(WifiModulationClass mc) const
 {
-    const auto& mcsList = GetPhy()->GetMcsList(WIFI_MOD_CLASS_HT);
-    WifiModeList htMcsList(mcsList.begin(), mcsList.end());
-    return htMcsList;
+    const auto& phyMcsList = GetPhy()->GetMcsList(mc);
+    WifiModeList mcsList(phyMcsList.cbegin(), phyMcsList.cend());
+    return mcsList;
 }
 
 } // namespace ns3
